//
//  ViewController.m
//  OAuthTest
//
//  Created by Sebastián Acuña Keller on 3/2/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"
#import "StartViewController.h"
#import "SGUser.h"

@implementation ViewController
@synthesize webView;
@synthesize authProvider;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    NSLog(@"loading %@", self.authProvider);
    NSString* urlAddress = [NSString stringWithFormat:@"http://dev.sports-guru.com/social/login/%@", self.authProvider];
    NSURL *url = [NSURL URLWithString:urlAddress];
    NSURLRequest *requestObj = [NSURLRequest requestWithURL: url];
    [webView loadRequest:requestObj];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType {
    NSString *path = [[request URL] path];
    NSString *interceptPath = [NSString stringWithFormat: @"/social/complete/%@", self.authProvider];
    NSLog(@"Loaded %@, waiting for %@", path, interceptPath);
    if( [path isEqualToString: interceptPath]) {
        NSURLConnection *conn = [NSURLConnection connectionWithRequest:request delegate:self];
        if (conn == nil) {
            NSLog(@"cannot create connection");
        }
        return NO;
    } else {
        return YES;
    }
}

- (void) connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    NSLog(@"connection:didReceiveResponse");
    
    if ([response isKindOfClass:[NSHTTPURLResponse class]]) {
        NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *) response;
//        int status = [httpResponse statusCode];
                
        // cancel the connection. we got what we want from the response,
        // no need to download the response data.
        [connection cancel];
        
        [self fetchUser];
    }
}

- (void) fetchUser {
    NSLog(@"Fetching user");

    RKObjectMapping* userMapping = [RKObjectMapping mappingForClass: [SGUser class]];
    [userMapping mapAttributes: @"screen_name", nil];
    [[RKObjectManager sharedManager] loadObjectsAtResourcePath:@"/user/me" objectMapping: userMapping delegate:self];
}


- (void)objectLoader:(RKObjectLoader *)objectLoader didLoadObjects:(NSArray *)objects {
    NSLog(@"Object loaded");
//    UIStoryboard* storyboard = [UIStoryboard storyboardWithName: @"MainStoryboard_iPhone" bundle: nil];
    StartViewController* startViewController = [self presentingViewController];
    SGUser* user = (SGUser *)[objects objectAtIndex:0];
    [startViewController.screenNameLabel setText: user.screen_name];
    [self dismissModalViewControllerAnimated: YES];
}

- (void)objectLoader:(RKObjectLoader *)objectLoader didFailWithErrors:(NSError *)error {
    NSLog(@"objectLoader didFailWithError %@", error);
}
@end